<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +-----------------------------------------------------------+
// | PHP version 4                                             |
// +-----------------------------------------------------------+
// | Copyright (c) Trond K. Pettersen @ http://lingo.uib.no    |
// | Any script (c) Lingo is subject to the GNU/GPL license.   |
// +-----------------------------------------------------------+
// | These scripts require that the PEAR base directory is in  |
// | your include_path. PEAR::DB is subject to the PHP license.|
// | See http://pear.php.net for help or more info on PEAR.    |
// +-----------------------------------------------------------+

// Might want to use XML and SAX later on...
// but for now ... quick and easy

// Check to ensure that script is not called "individually".
if(!defined('MOO2DB')) {
  header("HTTP/1.1 403 Forbidden");
  exit("<h1>403 Forbidden</h1>");
}

class Language 
{

  // Private
  var $separator;

  // Public
  var $furi;    // File URI
  var $strings; // Array String MOO Fetch_strings
  var $errors;  // Array String Error Msgs

  // Constructor
  function Language($uri='') 
  {
  
    $this->separator = '=>';  // Change this if MOO-side separator is changed
    $this->errors = array();
    $this->strings = array();
    
    $uri = trim($uri);
    if((substr($uri, 0, 7) != 'http://') || (ini_get('allow_url_fopen') != 1)) {
      $this->furi = (dirname(__FILE__).'/../language/default_lang.txt');
    } else {
      $this->furi = trim($uri);
    }
  
  }
  
  
  /**
       * Parses text file (hopefully from a nice MOO). 
       * Treats string before $this->sepearator as array key, string after sep. as value.
       *
       * @return void
       */
  function parse()
  {
  
    if(!$this->furi)
    {
      $this->errors[] = 'Empty language URI';
      return;
    }

    if(!($fp = fopen($this->furi, 'r'))) {
      $this->errors[] = sprintf('Failed to open language file "%s"', htmlentities($this->furi));
      return;
    }
    
    $string_data = '';
    while($data = fread($fp, 8192))  {
      $string_data .= $data;
    }
    
    $strings = explode("\n", $string_data);
        
    foreach ($strings as $str) {
      if(substr(trim($str), 0, 1) == '#') {
        // Treat line as comment
        continue;
      }
      $var = explode($this->separator, $str, 2);
      if($var && is_array($var) && (count($var) > 1)) {
        $this->strings[htmlentities(trim($var[0]))] = htmlentities(trim($var[1]));
      }
    }
    
  }
  
}

?>