<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// +-----------------------------------------------------------+
// | PHP version 4                                             |
// +-----------------------------------------------------------+
// | Copyright (c) Trond K. Pettersen @ http://lingo.uib.no    |
// | Any script (c) Lingo is subject to the GNU/GPL license.   |
// +-----------------------------------------------------------+
// | These scripts require that the PEAR base directory is in  |
// | your include_path. PEAR::DB is subject to the PHP license.|
// | See http://pear.php.net for help or more info on PEAR.    |
// +-----------------------------------------------------------+

/**
  * This script is used to authenticate MOOs.
  * A MOO calls this script when logging in (as MOO) in order
  * to enable the $uploader in that particular MOO
  */

define('MOO2DB', '1.0rc1');

require_once('./includes/common.php');

$moo = new MOO();

if(!$moo->db->connect()) {
  sendCookie('ERROR', 'ERROR_DB_CONNECT');
  sendHttpHeader(500, 'ERROR_DB_CONNECT');
}

// Authenticate MOO
$auth = $moo->auth();

if($auth !== true) {
  sendCookie('ERROR', 'ERROR_AUTH');
  sendHttpHeader(403, '403 Forbidden Fruit');
}

if(array_key_exists('logout', $_POST) && $_POST['logout'] == "1") {
  $moo->logout();
}

$moo->db->close();

sendCookie('moo_token', $moo->token);
sendHttpHeader(200, 'OK');

?>